struct gentype_rep;
struct gentype_inst;
typedef gentype_rep *gentype;

struct gentype_rep {
  inline gentype_rep () {
  }

  inline virtual ~gentype_rep () {
  }

  virtual gentype_inst gen_plus (gentype_inst, gentype_inst);
  virtual gentype_inst gen_minus (gentype_inst, gentype_inst);
  virtual gentype_inst gen_times (gentype_inst, gentype_inst);
  virtual bool gen_equal (gentype_inst, gentype_inst);
};

gentype_inst
gentype_rep::gen_plus (gentype_inst arg_1, gentype_inst arg_2) {
  cerr << "Fatal error: unsupported method\n";
  exit (1);
}

gentype_inst
gentype_rep::gen_minus (gentype_inst arg_1, gentype_inst arg_2) {
  cerr << "Fatal error: unsupported method\n";
  exit (1);
}

gentype_inst
gentype_rep::gen_times (gentype_inst arg_1, gentype_inst arg_2) {
  cerr << "Fatal error: unsupported method\n";
  exit (1);
}

bool
gentype_rep::gen_equal (gentype_inst arg_1, gentype_inst arg_2) {
  cerr << "Fatal error: unsupported method\n";
  exit (1);
}

struct gentype_inst {
  void *rep;

  inline gentype_inst (void *rep2) {
    rep = rep2;
  }

  inline ~gentype_inst () {
  }
};

static gentype gentype_cur_1;

struct gentype_inst_1 {
  void *rep;

  inline gentype_inst_1 (void *rep2) {
    rep = rep2;
  }

  inline ~gentype_inst_1 () {
  }
};

inline gentype_inst_1
concrete_1 (gentype_inst x) {
  return gentype_inst_1 (x.rep);
}

inline gentype_inst
abstract_1 (gentype_inst_1 x) {
  return gentype_inst (x.rep);
}

gentype_inst_1
operator + (gentype_inst_1 arg_1, gentype_inst_1 arg_2) {
  return concrete_1 (gentype_cur_1->gen_plus (abstract_1 (arg_1), abstract_1 (arg_2)));
}

gentype_inst_1
operator - (gentype_inst_1 arg_1, gentype_inst_1 arg_2) {
  return concrete_1 (gentype_cur_1->gen_minus (abstract_1 (arg_1), abstract_1 (arg_2)));
}

gentype_inst_1
operator * (gentype_inst_1 arg_1, gentype_inst_1 arg_2) {
  return concrete_1 (gentype_cur_1->gen_times (abstract_1 (arg_1), abstract_1 (arg_2)));
}

bool
operator == (gentype_inst_1 arg_1, gentype_inst_1 arg_2) {
  return gentype_cur_1->gen_equal (abstract_1 (arg_1), abstract_1 (arg_2));
}

struct gentype_int_rep: gentype_rep {
  gentype_inst gen_plus (gentype_inst, gentype_inst);
  gentype_inst gen_minus (gentype_inst, gentype_inst);
  gentype_inst gen_times (gentype_inst, gentype_inst);
};
