
/******************************************************************************
* MODULE     : list_test.cc
* DESCRIPTION: Test arrays and lists
* COPYRIGHT  : (C) 2000  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include <iostream>
#include <string.hh>
#include <array.hh>
#include <list.hh>
using namespace mmx;

generic
f (generic x) {
  return array (string ("Hopsa"), x, x);
}

generic
g (generic x) {
  return list (string ("Hola"), x, x);
}

int
main () {
  string s= "Hallo";
  cout << "s\t= " << s << "\n";
  cout << "----------------------------------------------------------------\n";
  cout << "f s\t= " << f(s) << "\n";
  cout << "f f s\t= " << f(f(s)) << "\n";
  cout << "cdr f s\t= " << cdr (f(s)) << "\n";
  cout << "----------------------------------------------------------------\n";
  cout << "g s\t= " << g(s) << "\n";
  cout << "g g s\t= " << g(g(s)) << "\n";
  cout << "cdr g s\t= " << cdr (g(s)) << "\n";
  return 0;
}
